All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the
213 basename of the directory that should be created when checking the
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
220 A few parameters have special meanings:
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
235 skip = test $(whoami) != joey
236 skip = [ "$1" = update ] && ! hours_since "$1" 12
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
260 Unlike all other parameters, this parameter does not need to be placed
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
285 Copyright 2007 Joey Hess <joey@kitenet.net>
287 Licensed under the GNU GPL version 2 or higher.
289 http://kitenet.net/~joey/code/mr/
298 use Cwd qw(getcwd abs_path);
308 print STDERR "mr: interrupted\n";
312 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
313 my $config_overridden=0;
323 my $directory=getcwd();
324 my (@ok, @failed, @skipped);
328 # This can happen if it's run in a directory that was removed
329 # or other strangeness.
330 if (! defined $directory) {
331 die("mr: failed to determine working directory\n");
333 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
334 # the config file might be a symlink to elsewhere, and the directory it's
336 if ($ENV{MR_CONFIG} !~ /^\//) {
337 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
339 # Try to set MR_PATH to the path to the program.
341 use FindBin qw($Bin $Script);
342 $ENV{MR_PATH}=$Bin."/".$Script;
346 loadconfig($ENV{MR_CONFIG});
348 #print Dumper(\%config);
350 my $action=expandaction(shift @ARGV);
357 elsif (! @ok && @skipped) {
367 # actions that do not operate on all repos
368 if ($action eq 'help') {
371 elsif ($action eq 'config') {
374 elsif ($action eq 'register') {
379 mrs($action, selectrepos());
382 foreach my $repo (selectrepos()) {
383 record($repo, action($action, @$repo));
389 my ($action, $dir, $topdir, $subdir) = @_;
392 foreach my $rcs_test (
394 length $a <=> length $b
397 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
398 my ($rcs)=$rcs_test=~/(.*)_test/;
399 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
400 $test.="if my_$rcs_test; then echo $rcs; fi\n";
402 $test=$config{$topdir}{$subdir}{lib}."\n".$test
403 if exists $config{$topdir}{$subdir}{lib};
405 print "mr $action: running rcs test >>$test<<\n" if $verbose;
416 sub findcommand { #{{{
417 my ($action, $dir, $topdir, $subdir) = @_;
419 if (exists $config{$topdir}{$subdir}{$action}) {
420 return $config{$topdir}{$subdir}{$action};
423 my $rcs=rcs_test(@_);
426 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
427 return $config{$topdir}{$subdir}{$rcs."_".$action};
435 my ($action, $dir, $topdir, $subdir) = @_;
437 $ENV{MR_CONFIG}=$configfiles{$topdir};
438 my $lib=exists $config{$topdir}{$subdir}{lib} ?
439 $config{$topdir}{$subdir}{lib}."\n" : "";
441 if ($action eq 'checkout') {
443 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
447 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
450 print "mr $action: creating parent directory $dir\n" if $verbose;
451 system("mkdir", "-p", $dir);
454 elsif ($action =~ /update/) {
456 return action("checkout", $dir, $topdir, $subdir);
462 my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
463 my $command=findcommand($action, $dir, $topdir, $subdir);
465 if (defined $skiptest) {
466 my $test="set -e;".$lib.
467 "my_action(){ $skiptest\n }; my_action '$action'";
468 print "mr $action: running skip test >>$test<<\n" if $verbose;
469 my $ret=system($test);
471 if (($? & 127) == 2) {
472 print STDERR "mr $action: interrupted\n";
476 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
480 if ($ret >> 8 == 0) {
481 print "mr $action: $dir skipped per config file\n" if $verbose;
486 if (! $no_chdir && ! chdir($dir)) {
487 print STDERR "mr $action: failed to chdir to $dir: $!\n";
490 elsif (! defined $command) {
491 my $rcs=rcs_test(@_);
492 if (! defined $rcs) {
493 print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
497 print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
503 print "mr $action: $topdir$subdir\n";
507 $s=~s/^\Q$topdir$subdir\E\/?//;
508 print "mr $action: $topdir$subdir (in subdir $s)\n";
510 $command="set -e; ".$lib.
511 "my_action(){ $command\n }; my_action ".
512 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
513 print "mr $action: running >>$command<<\n" if $verbose;
514 my $ret=system($command);
516 if (($? & 127) == 2) {
517 print STDERR "mr $action: interrupted\n";
521 print STDERR "mr $action: received signal ".($? & 127)."\n";
524 print STDERR "mr $action: failed ($ret)\n" if $verbose;
525 if ($ret >> 8 != 0) {
526 print STDERR "mr $action: command failed\n";
529 print STDERR "mr $action: command died ($ret)\n";
534 if ($action eq 'checkout' && ! -d $dir) {
535 print STDERR "mr $action: $dir missing after checkout\n";;
544 # run actions on multiple repos, in parallel
554 while (@fhs or @repos) {
555 while ($running < $jobs && @repos) {
557 my $repo = shift @repos;
558 pipe(my $outfh, CHILD_STDOUT);
559 pipe(my $errfh, CHILD_STDERR);
561 unless ($pid = fork) {
562 die "mr $action: cannot fork: $!" unless defined $pid;
563 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
564 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
569 exit action($action, @$repo);
573 push @active, [$pid, $repo];
574 push @fhs, [$outfh, $errfh];
577 my ($rin, $rout) = ('','');
579 foreach my $fh (@fhs) {
580 next unless defined $fh;
581 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
582 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
584 $nfound = select($rout=$rin, undef, undef, 1);
585 foreach my $channel (0, 1) {
586 foreach my $i (0..$#fhs) {
587 next unless defined $fhs[$i];
588 my $fh = $fhs[$i][$channel];
589 next unless defined $fh;
590 if (vec($rout, fileno($fh), 1) == 1) {
592 if (sysread($fh, $r, 1024) == 0) {
594 $fhs[$i][$channel] = undef;
595 if (! defined $fhs[$i][0] &&
596 ! defined $fhs[$i][1]) {
597 waitpid($active[$i][0], 0);
598 print STDOUT $out[$i][0];
599 print STDERR $out[$i][1];
600 record($active[$i][1], $? >> 8);
602 splice(@active, $i, 1);
607 $out[$i][$channel] .= $r;
615 my $dir=shift()->[0];
622 elsif ($ret == FAILED) {
626 elsif ($ret == SKIPPED) {
629 elsif ($ret == ABORT) {
633 die "unknown exit status $ret";
638 if (! @ok && ! @failed && ! @skipped) {
639 die "mr $action: no repositories found to work on\n";
641 print "mr $action: finished (".join("; ",
642 showstat($#ok+1, "ok", "ok"),
643 showstat($#failed+1, "failed", "failed"),
644 showstat($#skipped+1, "skipped", "skipped"),
648 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
651 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
661 return "$count ".($count > 1 ? $plural : $singular);
666 # an ordered list of repos
669 foreach my $topdir (sort keys %config) {
670 foreach my $subdir (sort keys %{$config{$topdir}}) {
674 order => $config{$topdir}{$subdir}{order},
679 $a->{order} <=> $b->{order}
681 $a->{topdir} cmp $b->{topdir}
683 $a->{subdir} cmp $b->{subdir}
687 # figure out which repos to act on
688 sub selectrepos { #{{{
690 foreach my $repo (repolist()) {
691 my $topdir=$repo->{topdir};
692 my $subdir=$repo->{subdir};
694 next if $subdir eq 'DEFAULT';
695 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
697 $dir.="/" unless $dir=~/\/$/;
698 $d.="/" unless $d=~/\/$/;
699 next if $no_recurse && $d ne $dir;
700 next if $dir ne $d && $dir !~ /^\Q$d\E/;
701 push @repos, [$dir, $topdir, $subdir];
704 # fallback to find a leaf repo
705 foreach my $repo (reverse repolist()) {
706 my $topdir=$repo->{topdir};
707 my $subdir=$repo->{subdir};
709 next if $subdir eq 'DEFAULT';
710 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
712 $dir.="/" unless $dir=~/\/$/;
713 $d.="/" unless $d=~/\/$/;
714 if ($d=~/^\Q$dir\E/) {
715 push @repos, [$dir, $topdir, $subdir];
725 sub loadconfig { #{{{
732 if (ref $f eq 'GLOB') {
741 my $absf=abs_path($f);
742 if ($loaded{$absf}) {
747 ($dir)=$f=~/^(.*\/)[^\/]+$/;
748 if (! defined $dir) {
751 $dir=abs_path($dir)."/";
753 if (! exists $configfiles{$dir}) {
754 $configfiles{$dir}=$f;
757 # copy in defaults from first parent
759 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
760 if ($parent eq '/') {
763 if (exists $config{$parent} &&
764 exists $config{$parent}{DEFAULT}) {
765 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
770 print "mr: loading config $f\n" if $verbose;
771 open($in, "<", $f) || die "mr: open $f: $!\n";
782 next if /^\s*\#/ || /^\s*$/;
783 if (/^\[([^\]]*)\]\s*$/) {
786 elsif (/^(\w+)\s*=\s*(.*)/) {
791 while (@lines && $lines[0]=~/^\s(.+)/) {
798 if ($parameter eq "include") {
799 print "mr: including output of \"$value\"\n" if $verbose;
800 unshift @lines, `$value`;
804 if (! defined $section) {
805 die "$f line $.: parameter ($parameter) not in section\n";
807 if ($section ne 'ALIAS' &&
808 ! exists $config{$dir}{$section} &&
809 exists $config{$dir}{DEFAULT}) {
811 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
813 if ($section eq 'ALIAS') {
814 $alias{$parameter}=$value;
816 elsif ($parameter eq 'lib') {
817 $config{$dir}{$section}{lib}.=$value."\n";
820 $config{$dir}{$section}{$parameter}=$value;
821 if ($parameter =~ /.*_(.*)/) {
825 $knownactions{$parameter}=1;
827 if ($parameter eq 'chain' &&
828 length $dir && $section ne "DEFAULT" &&
829 -e $dir.$section."/.mrconfig") {
830 my $ret=system($value);
832 if (($? & 127) == 2) {
833 print STDERR "mr $action: chain test interrupted\n";
837 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
841 push @toload, $dir.$section."/.mrconfig";
847 die "$f line $line: parse error\n";
856 sub modifyconfig { #{{{
858 # the section to modify or add
859 my $targetsection=shift;
860 # fields to change in the section
861 # To remove a field, set its value to "".
868 open(my $in, "<", $f) || die "mr: open $f: $!\n";
873 my $formatfield=sub {
875 my @value=split(/\n/, shift);
877 return "$field = ".shift(@value)."\n".
878 join("", map { "\t$_\n" } @value);
882 while ($out[$#out] =~ /^\s*$/) {
883 unshift @blanks, pop @out;
885 foreach my $field (sort keys %changefields) {
886 if (length $changefields{$field}) {
887 push @out, "$field = $changefields{$field}\n";
888 delete $changefields{$field};
898 if (/^\s*\#/ || /^\s*$/) {
901 elsif (/^\[([^\]]*)\]\s*$/) {
902 if (defined $section &&
903 $section eq $targetsection) {
911 elsif (/^(\w+)\s*=\s(.*)/) {
916 while (@lines && $lines[0]=~/^\s(.+)/) {
922 if ($section eq $targetsection) {
923 if (exists $changefields{$parameter}) {
924 if (length $changefields{$parameter}) {
925 $value=$changefields{$parameter};
927 delete $changefields{$parameter};
931 push @out, $formatfield->($parameter, $value);
935 if (defined $section &&
936 $section eq $targetsection) {
939 elsif (%changefields) {
940 push @out, "\n[$targetsection]\n";
941 foreach my $field (sort keys %changefields) {
942 if (length $changefields{$field}) {
943 push @out, $formatfield->($field, $changefields{$field});
948 open(my $out, ">", $f) || die "mr: write $f: $!\n";
954 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
959 die "mr config: not enough parameters\n";
962 if ($section=~/^\//) {
963 # try to convert to a path relative to the config file
964 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
966 $dir.="/" unless $dir=~/\/$/;
967 if ($section=~/^\Q$dir\E(.*)/) {
973 if (/^([^=]+)=(.*)$/) {
974 $changefields{$1}=$2;
978 foreach my $topdir (sort keys %config) {
979 if (exists $config{$topdir}{$section} &&
980 exists $config{$topdir}{$section}{$_}) {
981 print $config{$topdir}{$section}{$_}."\n";
983 last if $section eq 'DEFAULT';
987 die "mr $action: $section $_ not set\n";
991 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
996 if (! $config_overridden) {
997 # Find the closest known mrconfig file to the current
999 $directory.="/" unless $directory=~/\/$/;
1000 foreach my $topdir (reverse sort keys %config) {
1001 next unless length $topdir;
1002 if ($directory=~/^\Q$topdir\E/) {
1003 $ENV{MR_CONFIG}=$configfiles{$topdir};
1010 my $subdir=shift @ARGV;
1011 if (! chdir($subdir)) {
1012 print STDERR "mr $action: failed to chdir to $subdir: $!\n";
1016 $ENV{MR_REPO}=getcwd();
1017 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
1018 if (! defined $command) {
1019 die "mr $action: unknown repository type\n";
1022 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1023 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1024 "my_action(){ $command\n }; my_action ".
1025 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1026 print "mr $action: running >>$command<<\n" if $verbose;
1027 exec($command) || die "exec: $!";
1030 # alias expansion and command stemming
1031 sub expandaction { #{{{
1033 if (exists $alias{$action}) {
1034 $action=$alias{$action};
1036 if (! exists $knownactions{$action}) {
1037 my @matches = grep { /^\Q$action\E/ }
1038 keys %knownactions, keys %alias;
1039 if (@matches == 1) {
1040 $action=$matches[0];
1042 elsif (@matches == 0) {
1043 die "mr: unknown action \"$action\" (known actions: ".
1044 join(", ", sort keys %knownactions).")\n";
1047 die "mr: ambiguous action \"$action\" (matches: ".
1048 join(", ", @matches).")\n";
1055 Getopt::Long::Configure("no_permute");
1056 my $result=GetOptions(
1057 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1058 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1059 "v|verbose" => \$verbose,
1060 "s|stats" => \$stats,
1061 "n|no-recurse" => \$no_recurse,
1062 "j|jobs=i" => \$jobs,
1064 if (! $result || @ARGV < 1) {
1065 die("Usage: mr [-d directory] action [params ...]\n".
1066 "(Use mr help for man page.)\n");
1070 # Finally, some useful actions that mr knows about by default.
1071 # These can be overridden in ~/.mrconfig.
1087 echo "mr (warning): $@" >&2
1093 if [ -z "$1" ] || [ -z "$2" ]; then
1094 error "mr: usage: hours_since action num"
1096 for dir in .git .svn .bzr CVS .hg _darcs; do
1097 if [ -e "$MR_REPO/$dir" ]; then
1098 flagfile="$MR_REPO/$dir/.mr_last$1"
1102 if [ -z "$flagfile" ]; then
1103 error "cannot determine flag filename"
1105 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
1106 if [ "$delta" -lt "$2" ]; then
1114 svn_test = test -d "$MR_REPO"/.svn
1115 git_test = test -d "$MR_REPO"/.git
1116 bzr_test = test -d "$MR_REPO"/.bzr
1117 cvs_test = test -d "$MR_REPO"/CVS
1118 hg_test = test -d "$MR_REPO"/.hg
1119 darcs_test = test -d "$MR_REPO"/_darcs
1121 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1122 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1123 test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
1125 svn_update = svn update "$@"
1126 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1127 bzr_update = bzr merge "$@"
1128 cvs_update = cvs update "$@"
1129 hg_update = hg pull "$@" && hg update "$@"
1130 darcs_update = darcs pull -a "$@"
1132 svn_status = svn status "$@"
1133 git_status = git status "$@" || true
1134 bzr_status = bzr status "$@"
1135 cvs_status = cvs status "$@"
1136 hg_status = hg status "$@"
1137 darcs_status = darcs whatsnew -ls "$@"
1139 svn_commit = svn commit "$@"
1140 git_commit = git commit -a "$@" && git push --all
1141 bzr_commit = bzr commit "$@" && bzr push
1142 cvs_commit = cvs commit "$@"
1143 hg_commit = hg commit -m "$@" && hg push
1144 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1146 svn_diff = svn diff "$@"
1147 git_diff = git diff "$@"
1148 bzr_diff = bzr diff "$@"
1149 cvs_diff = cvs diff "$@"
1150 hg_diff = hg diff "$@"
1151 darcs_diff = darcs diff "$@"
1153 svn_log = svn log "$@"
1154 git_log = git log "$@"
1155 bzr_log = bzr log "$@"
1156 cvs_log = cvs log "$@"
1157 hg_log = hg log "$@"
1158 darcs_log = darcs changes "$@"
1159 git_bare_log = git log "$@"
1162 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1163 if [ -z "$url" ]; then
1164 error "cannot determine svn url"
1166 echo "Registering svn url: $url in $MR_CONFIG"
1167 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1169 url="$(LANG=C git-config --get remote.origin.url)" || true
1170 if [ -z "$url" ]; then
1171 error "cannot determine git url"
1173 echo "Registering git url: $url in $MR_CONFIG"
1174 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1176 url=$(cat .bzr/branch/parent)
1177 if [ -z "$url" ]; then
1178 error "cannot determine bzr url"
1180 echo "Registering bzr url: $url in $MR_CONFIG"
1181 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
1183 repo=$(cat CVS/Repository)
1184 root=$(cat CVS/Root)
1185 if [ -z "$root" ]; then
1186 error "cannot determine cvs root"
1188 echo "Registering cvs repository $repo at root $root"
1189 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1191 url=$(hg showconfig paths.default)
1192 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1193 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1195 url=$(cat _darcs/prefs/defaultrepo)
1196 echo "Registering darcs repository $url in $MR_CONFIG"
1197 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
1199 url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
1200 if [ -z "$url" ]; then
1201 error "cannot determine git url"
1203 echo "Registering git url: $url in $MR_CONFIG"
1204 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1207 if [ ! -e "$MR_PATH" ]; then
1208 error "cannot find program path"
1210 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1214 ed = echo "A horse is a horse, of course, of course.."
1215 T = echo "I pity the fool."
1216 right = echo "Not found."
1219 # vim:sw=8:sts=0:ts=8:noet